#ifndef _ITEM_SET10EM_CLASS_
#define _ITEM_SET10EM_CLASS_

// mod 10/10 to remove LstArray class references
// mod dt 2/9/99, and lots more since then up to 8/02
// most recently to become the second IRT04* for 285, 10/04

#include <iostream>
#include <sstream>   // added 3/98 dt for ReadCol
#include <fstream>	// dt 1/23/99
#include <iomanip>	//
#include <string>
#include <vector>
#include <valarray>
#include "ItemStuf.h"

#define kZeroByte 0

using namespace std;		// namespace std is now conventional in C++ code

class IRT10em {

// A class made up of classes of type ItemStuff, 
// also includes nitem, maxscore, and the name of the parameter file

public:

	static int size;

	int nitem;
	int maxscore;
	char DatFile[64];
	ItemStuff* I;  // pointer to an ItemStuff

	valarray<double> eap;  
	valarray<double> sd;  
	valarray<double> wt;
	valarray<double> expd;
	vector< valarray<double> > lk;  // pointer to DblList, added, dt, 7/98

// from here down are the basic global variables for the Scaled Score App
// Some of this stuff isn't used in the MFS routine, but it's hanging
// around here anyway---dt, 7/98
	static int nqpt;	// quadrature
	static double qpmax;// settings
	int aCol;	// column a is in for columns input
	int bCol;	// ditto b
	valarray<int> bColList;  // columns for b's
	int cCol;	// ditto c

	static valarray<double> theta;  // the theta list
	static valarray<double> popdist;  // the normal ordinates


	IRT10em();
	~IRT10em();

	void ChangeNitems(int n);
	void ChangeMaxScore(int m);

	void graded (int i);
// graded: input is the item index number i, telling where in IRT04em this goes;
// as output, it places in test.I[i].T[x] a DblList of each
// trace line's ordinate at each of the values of theta

	void threePL (int i);
// threePL: input is the item index number i, telling where in IRT04em this goes;
// the doubles for parameters a, b, and c
// (as currently written, this uses the 1.7,
// and would not respond to a flag about that)
// as output, it places in test.I[i].T[x] a DblList of each
// trace line's ordinate at each of the values of theta

	void int_stats(valarray<double>& posterior, int score);
// int_stats: close copy of the LISP function of the same name---
// input is a DblList representing posterior likelihood, the theta DblList,
// and a summed score that indicates where in the output the results go---
// computes EAP, S.D., and P for the posterior, as well as (optionally)
// rounded integer scale scores if mu and sigma for those are not 0 and 1

	void int_statsR(valarray<double>& posterior, 
				double& expdvalue, double& eapvalue, double& sdvalue);
// int_statsR--this is a simpler version that just computes the statistics
// and returns them, for use with Demo()

	void recursive ();
// the first 24 lines comprise a close clone of the LISP we did (not)
// publish in the '95 APM article; it's in the Lab text report

	void WriteIt (); // console C++ output

private:

};

#endif /* _ITEM_SET10EM_CLASS_ */

