#ifndef _ITEM_STUFF_CLASS_
#define _ITEM_STUFF_CLASS_

// mod 10/10 to remove LstArray class references
// mod dt 2/9/99
// relative to the version used for the 285 IRTScore2s,
// thie one lacks IEAP and IEwt and hast the 3PL and E stuff...
// (dt, 1004)

#include <vector>
#include <valarray>

using namespace std;		// namespace std is now conventional in C++ code

class ItemStuff {

// A beginning item class. For each item, it contains:
// kind is the Multilog kind: 1=graded, 2=3PL or nominal
//  (this version only does graded and 3PL)
// ncat = integer number of categories
// a, b, and c if it's 3PL
// a and bj if it's graded
// an array of ncat DblLists called T
// (presumably, of default size = number of quadrature points)
// that can be filled with the trace-line ordinates

// later, we can add nominal, multiple-choice, info curves for all, etc.

// must ChangeSize each of these before use

public:

	static int size;
 	void ChangeSize(int);
	int kind;
	int ncat;
	double cPmean;
	double a;
	double b;
	double c;
	valarray<double> bj; // dt mod 10/10
	vector< valarray<double> > T;  //pointer to DblList dt mod 10/10
	vector< valarray<double> > E;  // EM added; pointer to DblArray dt mod 10/10

// default constructor
ItemStuff(); // in ItemStuff.cp

// destructor for DblList
~ItemStuff(); // in ItemStuff.c

// sets the default constructor size, used when making arrays of these
static void setncat(int n); // in ItemStuff.c

private:

};
#endif /* _ITEM_STUFF_CLASS_ */

