#include <ctime>
#include <iostream>
#include "TestData10em.h"
#include "mynewmat.h"
#define kZeroByte 0
#define missing -1	// added dt 12/00 for missing data mods

extern ofstream outfile1;

// mod 10/10 to remove LstArray class references
// 10/04 all vestiges of groups removed when it became 285 version
// modded from IRTLRDIF back down to one group dt 8/02
// mod dt 2/9/99 EM
// New version distributed by JLV 3/16/99
// dt mods 3-4/99 to do graded model, and 5/20/99 clean up

// the class that defines the log-likelihood
// modified from the GARCH example in the newmat09 distribution, dt, 1/99

// mods dt 11/21/00 for irtlrdif---remove dependency on matrices from subscores version


// default constructor
TestData::TestData() { //  changed to null dt 1/23/99
}
// default destructor
TestData::~TestData() { 
}

void TestData::ChangeSize(int np, int ni) {
	int i;
	
	for (i = 0; i < 64; i++)
		DatFile[i] = kZeroByte;
	nppl = np;
	nitems = ni;
	NcatCode.resize(ni);
	X.resize(np);
	for (int i=0; i<np; i++)
		X[i].resize(ni);
}

void TestData::GetFileI(char szSavedFileName[]) {
	cout << "Enter Input File Name: ";
	cin.getline(szSavedFileName, 64);	
} // end of GetFileI

void TestData::GetFileO(char szSavedFileName[]) {
	cout << "Enter Output File Name: ";
	cin.getline(szSavedFileName, 64);	
} // end of GetFileO

void TestData::RData(void) {
	char datline[256];	// this is set up for 255 
                        // columns plus endline character
	char selected[256]; // this is for the item-columns selected
	int np; 			// number of people
	int ni; 			// number of items
	int nread; 			// accumulates number read, starts at 0
	char ParseInput[256]; // for input line of item-number ranges
	char comma[] = ",";
	char hyphen[] = "-";
	char blank[] = " ";
	char* SubString;
	char* SubString2;
	int* first; 		// begin of item blocks
	int* second; 		// end of item blocks
	int nblocks = 0; 	// number of blocks
	int ItemsInBlock;
	int i, block, i1;
	char r[2];
	char HexPlus[37] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	cout << "Enter number of examinees: ";
	cin >> np;	
	cout << "Enter number of items: ";
	cin >> ni;	
	cin.get();			// this deals with extra <cr> on input
	ChangeSize(np, ni);
	
	r[1] = kZeroByte;
	for(i = 0; i < ni; i++)
		NcatCode[i] = 1;	// new 3/99 dt
	cout << "Enter a list of numbers of categories for the items (no spaces);" << endl
             << "(use 1 for 3PL items; <CR> for all 3PL):" << endl;
	cin.getline(ParseInput, 256);	// codes read as alphabetics
	if (strlen(ParseInput)) {		// here we are limited to 9 categories or fewer
		for(i = 0; i < ni; i++) {	// by the one-character ncat input format
			strncpy(r, &ParseInput[i],1);	// copy each character and
			NcatCode[i] = atoi(r);			// convert to integer value---new 3/99 dt
		}
	}

	GetFileI(DatFile);	// get the input file name

	cout << "Enter number of alternatives for 3PL items: ";
	cin >> nAlts;		// number of multile choice alternatives (for setting c-prior)
	cin.get();			// this deals with extra <cr> on input

// ***** the following block decodes the comma'd, hyphened lists of column numbers *****
//       into lists to control the loops to bring in the item responses
	first = new int[ni];
	second = new int[ni];
	cout << "Enter the list of column-numbers for the items:" << endl;
	cin.getline(ParseInput, 256); 
	SubString = strtok(ParseInput, comma);
	
	do {
		first[nblocks] = atoi(SubString);
		SubString2=strstr(SubString,hyphen);
		if (SubString2 != NULL)
			{SubString2[0] = blank[0];}
	    second[nblocks] =(SubString2 != NULL)? atoi(SubString2):0;
		if (second[nblocks] == 0)
			second[nblocks] = first[nblocks];
		nblocks++;
	}

	while ((SubString = strtok(NULL, comma)) != NULL);
	cout << "Items   From Columns:" << endl;
   
	for (block = 0, i1 = 1; block < nblocks; block++) {
		ItemsInBlock = second[block] - first[block];
		cout << i1 << "-" << i1 + ItemsInBlock << "    " <<
			first[block] << "-" << second[block] << endl;
		i1 = i1 + ItemsInBlock + 1;
	}
// ***** this ends the block that decodes the comma'd, hyphened lists of column numbers *****

	{ 			// this brace gives ifstream dat its scope
	ifstream dat(DatFile);
	nread = 0;
		do {
			dat.getline(datline, 256, '\n');
			if (strlen(datline) > 0) {
				for (int block = 0, iloc = 0; block < nblocks; block++) {
					for (int col = first[block]; col < second[block] + 1; col++) {
						selected[iloc] = datline[col - 1];
						iloc++;
					}
				}
				for (i = 0; i < ni; i++) {
					if (NcatCode[i] == 1) {
						if (selected[i] == ' ') X[nread][i] = missing; // mod missing 12/00
						else {
							if (selected[i] == '1') X[nread][i] = 1;
							else X[nread][i] = 0;
						}
					}
					else {
						if (selected[i] == ' ') X[nread][i] = missing; // mod missing 12/00
						else {
							for (i1 = 0; i1 < NcatCode[i]; i1++) {
								if (selected[i] == HexPlus[i1]) X[nread][i] = i1;
							}
						}
					}	// this needs some error-checking; design later?
				} 
				nread++;
			} // end of if (strlen(datline))...

			if (nread == nppl) break; // inserted so we can do subsets of data files
		} //end of do while not EOF on data file
		while (!dat.eof()); 
	}
	cout << nread << " data lines read" << endl;
}

void TestData::WFirstLast(int howmany) {
// routine to summarize data input for larger objects	
    int i,p;

	cout << endl << "From theData object:" << endl;
	cout << "Number of examinees: " << nppl << endl;
	cout << "Number of items: " << nitems << endl;
	cout << "Numbers of categories for the items (1 for 3PL items):" << endl;
	for(i = 0; i < nitems; i++)
		cout << NcatCode[i];	// new 3/99 dt
	cout << endl;
	cout << "From data file: ";
    outfile1 << endl << "From theData object:" << endl;
	outfile1 << "Number of examinees: " << nppl << endl;
	outfile1 << "Number of items: " << nitems << endl;
	outfile1 << "Numbers of categories for the items (1 for 3PL items):" << endl;
	for(i = 0; i < nitems; i++)
		outfile1 << NcatCode[i];	// new 3/99 dt
	outfile1 << endl;
	outfile1 << "From data file: ";
    
	for (i = 0; i < strlen(DatFile); i++)
		{cout << DatFile[i];
         outfile1 << DatFile[i];}
	cout << endl;
	outfile1 << endl;
	cout << "The first and last " << howmany << 
                " items:" << endl;
    outfile1 << "The first and last " << howmany << 
                " items:" << endl;

	for (p = 0; p < howmany; p++) {
		for (i = 0; i < nitems; i++) {
			cout << (int) X[p][i];
			outfile1 << (int) X[p][i];
         }
		cout << endl;
		outfile1 << endl;
	}
		cout << endl;
		outfile1 << endl;

	for (p = nppl-howmany; p < nppl; p++) {
		for (i = 0; i < nitems; i++) {
			cout << (int) X[p][i];
			outfile1 << (int) X[p][i];
		}
		cout << endl;
		outfile1 << endl;
	}
		cout << endl;
		outfile1 << endl;
}


class M3PL_LL : public LL_D_FI
{
   ColumnVector D;                 // derivatives of loglikelihood
   SymmetricMatrix D2;             // second derivatives
   Real a,c,g,logitg;              // the parameters
   double Pmean;	// moved 12/00 for irtlrdif / why did this used to be 1.1?
   int Item;
   ItemStuff *theItem;

public:

   M3PL_LL(ItemStuff *theitem, const int item)
   	: theItem(theitem), Item(item) {}

   void Set(const ColumnVector& p) { // set parameter values
      para = p; a = para(1); c = para(2); logitg = para(3);
	  Pmean = (*theItem).cPmean;
   }

   bool IsValid();                 // are parameters valid
   Real LogLikelihood();           // return the loglikelihood
   ReturnMatrix Derivatives();     // derivatives of log-likelihood
   ReturnMatrix FI();              // Fisher Information matrix
};

bool M3PL_LL::IsValid() {
	 return true;
}

Real M3PL_LL::LogLikelihood() {
	Real LL = 0.0;          // the log likelihood
   
	LogAndSign ld;
	int i;
	double Psd = 0.5;	// hard-coded prior SD for logit g
	double z;			// note: mean for logit g is logit(1/nalt)
	double gg, T2PL, T, TTM1, dTda, dTdc, dTdlogitg, N, dif;
	extern ofstream outfile1;
	extern int lots;
   
	D.ReSize(3);
	D << 0.0 << 0.0 << 0.0;
	D2.ReSize(3);
	D2 << 0.0 << 0.0 << 0.0 << 0.0 << 0.0 << 0.0;
	gg = 1.0 / (1.0 + exp(-logitg));
	for (i=0; i<IRT10em::nqpt; i++) {
   		z = a*1.7*IRT10em::theta[i] + c;
   		if (z < -20.0) z = -20.0;
   		if (z > 20.0) z = 20.0;
   		T2PL = 1.0 / (1.0 + exp(-z));
// 4 lines above mimic multilog protection from too-small p's
   		T = gg + (1.0 - gg)*T2PL;
    	TTM1 = T*(1.0 - T);
   		LL += ((*theItem).E[i][1]*log(T) +  (*theItem).E[i][0]*log(1.0 - T));
   		dTda = 1.7*(IRT10em::theta[i]*(T - gg)*(1.0 - T))/(1.0 - gg);
   		dTdc = ((T - gg)*(1.0 - T))/(1.0 - gg);	// this version modified to be
   		dTdlogitg = gg*(1.0 - gg)*(1.0 - T2PL);	// a-c-g 1/23/99
   		N = (*theItem).E[i][1] + (*theItem).E[i][0];
   		dif = ((*theItem).E[i][1]/N) - T;
   		D(1) += (N*dif*dTda)/TTM1;
   		D(2) += (N*dif*dTdc)/TTM1;
   		D(3) += (N*dif*dTdlogitg)/TTM1;
   		if (wg) {                  // do only if second derivatives wanted
   			D2(1,1) += (N*dTda*dTda)/TTM1;
   			D2(2,2) += (N*dTdc*dTdc)/TTM1;
   			D2(3,3) += (N*dTdlogitg*dTdlogitg)/TTM1;
   			D2(2,1) += (N*dTda*dTdc)/TTM1;
   			D2(3,1) += (N*dTda*dTdlogitg)/TTM1;
   			D2(3,2) += (N*dTdc*dTdlogitg)/TTM1;
		}
	} // end of loop over qpts
	z = (logitg - Pmean) / Psd;	// these four lines add the g-prior
	LL -= 0.5*z*z;
	D(3) -= z / Psd;
	if (wg) D2(3,3) += 1.0 / (Psd*Psd);
	if (lots > 1) {
   		outfile1 << "para " << a << " " << c << " " << logitg << endl;
   		outfile1 << "LL " << LL << endl;
	}
	if (lots > 2) outfile1 << D;
	if (wg && (lots > 3)) outfile1 << D2;
   return LL;
}

ReturnMatrix M3PL_LL::Derivatives()
{ return D; }

ReturnMatrix M3PL_LL::FI() {
   if (!wg) cout << endl << "unexpected call of FI" << endl;
   return D2;
}

class MGR_LL : public LL_D_FI
{
	ColumnVector D;                 // derivatives of loglikelihood
	SymmetricMatrix D2;             // second derivatives
	int ncats;                      // number of categories
	Real a;              			// the slope parameter
	ColumnVector c;
	int Item;
    ItemStuff *theItem;

public:
	MGR_LL(ItemStuff *theitem, const int item)
   	: theItem(theitem), Item(item) {}

	void Set(const ColumnVector& p) {
		int k;
		ncats = (*theItem).ncat;
		c.ReSize(ncats-1);	 // set parameter values
		para = p;
		a = para(1);
		for (k = 1; k < ncats; k++) 
			c(k) = para(k+1);
	}

	bool IsValid();                 // are parameters valid
	Real LogLikelihood();           // return the loglikelihood
	ReturnMatrix Derivatives();     // derivatives of log-likelihood
	ReturnMatrix FI();              // Fisher Information matrix
};

bool MGR_LL::IsValid() {
	int k;
	if (a == 0.0) return false;
	for (k = 1; k < (ncats - 1); k++)
	  if (c(k) < c(k + 1)) return false;
	return true; 
}

Real MGR_LL::LogLikelihood() {
	Real LL = 0.0;          // the log likelihood
	double T, Tl, Tr, wl, wr, f;
	double zr,zl;
	int i, j, k;
	D.ReSize(ncats);
	D2.ReSize(ncats);
	for (i = 1; i <= ncats; i++) {
		D(i) =0.0;
		for (j = 1; j <= i; j++) 
			D2(i,j) = 0.0;
	}
	for (i=0; i<IRT10em::nqpt; i++) {
// begin attempt to do using Baker's derivs, 3/21/99
// note that Baker has it set up slope-intercept
	f = 0.0;
	for (k = 0; k < ncats; k++) f += (*theItem).E[i][k];
// leftmost component (0 or 1)
		zr = a*IRT10em::theta[i] + c(1);
		if (zr < -30.0) zr = -30.0;
		if (zr > 30.0) zr = 30.0;
   		Tr = 1.0 / (1.0 + exp(-zr));
// 4 lines above to mimic multilog protection from zeroish p's
   		T = 1.0 - Tr;
		if (T < 1.0e-20) T = 1.0e-20;
   		LL += (*theItem).E[i][0]*log(T);
   		wr = Tr*(1.0-Tr);
   		D(1) += -IRT10em::theta[i]*((*theItem).E[i][0]/T)*(wr);
   		D(2) += -wr*( (*theItem).E[i][0]/T);
		if (wg) {                   // do only if second derivatives wanted
   			D2(1,1) +=  f*IRT10em::theta[i]*IRT10em::theta[i]*(wr)*(wr)/T;
   			D2(2,2) +=  f*wr*wr/T;
   				D2(2,1) +=  f*wr*IRT10em::theta[i]*(wr)/T;
		}
// middle components 
   		for (k = 2; k < ncats; k++) {
			zl = a*IRT10em::theta[i] + c(k-1);
			if (zl < -30.0) zl = -30.0;
			if (zl > 30.0) zl = 30.0;
  	 		Tl = 1.0 / (1.0 + exp(-zl));
// 4 lines above to mimic multilog protection from zero p's
			zr = a*IRT10em::theta[i] + c(k);
			if (zr < -30.0) zr = -30.0;
			if (zr > 30.0) zr = 30.0;
   			Tr = 1.0 / (1.0 + exp(-zr));
// 4 lines above to mimic multilog protection from zero p's
   			T = Tl - Tr;
			if (T < 1.0e-20) T = 1.0e-20;
   			LL += (*theItem).E[i][k-1]*log(T);
   			wl = Tl*(1.0-Tl);
   			wr = Tr*(1.0-Tr);
   			D(1) += IRT10em::theta[i]*((*theItem).E[i][k-1]/T)*(wl - wr);
   			D(k) += -wl*(-(*theItem).E[i][k-1]/T);
   			D(k+1) += -wr*( (*theItem).E[i][k-1]/T);
			if (wg) {                   // do only if second derivatives wanted
   				D2(1,1) +=  f*IRT10em::theta[i]*IRT10em::theta[i]*(wl - wr)*(wl - wr)/T;
   				D2(k,k) +=  f*wl*wl/T;
   				D2(k+1,k+1) +=  f*wr*wr/T;
   				D2(k,1) +=  f*wl*IRT10em::theta[i]*(wl - wr)/T;
   				D2(k+1,1) += -f*wr*IRT10em::theta[i]*(wl - wr)/T;
   				D2(k+1,k) += -f*wl*wr/T; 
			}
		} // end of loop over middle components
// rightmost component (ncats - 1 or ncats)
		zl = a*IRT10em::theta[i] + c(ncats-1);
		if (zl < -30.0) zl = -30.0;
		if (zl > 30.0) zl = 30.0;
  	 	Tl = 1.0 / (1.0 + exp(-zl));
// 4 lines above to mimic multilog protection from zero p's
   		T = Tl;
		if (T < 1.0e-20) T = 1.0e-20;
  	 	LL += (*theItem).E[i][ncats-1]*log(T);
   		wl = Tl*(1.0-Tl);
   		D(1) += IRT10em::theta[i]*((*theItem).E[i][ncats-1]/T)*(wl);
   		D(ncats) += -wl*(-(*theItem).E[i][ncats-1]/T);
		if (wg) {                   // do only if second derivatives wanted
   			D2(1,1) +=  f*IRT10em::theta[i]*IRT10em::theta[i]*(wl)*(wl)/T;
   			D2(ncats,ncats) +=  f*wl*wl/T;
   			D2(ncats,1) +=  f*wl*IRT10em::theta[i]*(wl)/T;
		}
	} // end of for-loop over X-levels
	return LL;
}

ReturnMatrix MGR_LL::Derivatives() { return D; }

ReturnMatrix MGR_LL::FI() {
	if (!wg) cout << endl << "unexpected call of FI" << endl;
	return D2;
}


void TestData::EMfit() {
	int i, k, p, q, cycle, ncats, item;
	IRT10em *test;
	valarray<double> likelihood; 
	double loglikelihood, maxchange, maxcheck;
	ColumnVector Para(3);               // to hold the parameters
	ColumnVector ParaOld(3);            // to hold the last cycle parameters
	clock_t Etime1, Etime2, Mtime1, Mtime2;
	double Etime, Mtime;
	extern int lots;
	int *x; 
	test = theIRTstruct;
	int Items = nitems;

	Etime = 0;
	Mtime = 0;
	
// initialize each item in the IRT structure and create the E tables
   	for (i = 0; i < Items; i++) {
   	item = i;
   		if (NcatCode[item] == 1) {
			(*test).I[i].a = 1.0;	// these lines
			(*test).I[i].b = 0.0;	// represent starting values/initialization
			(*test).I[i].c = 1.0/nAlts;	
			(*test).I[i].kind = 2;
			(*test).I[i].cPmean = log((1.0/nAlts)/(1.0 - (1.0/nAlts)));
			for (int j=0; j<2; j++)
				(*test).I[i].T[j].resize(IRT10em::nqpt);
   			(*test).threePL(i);
   			(*test).I[i].E.resize(IRT10em::nqpt);
			for (int q=0; q<IRT10em::nqpt; q++)
				(*test).I[i].E[q].resize((*test).I[i].ncat);
   		}
   		if (NcatCode[item] > 1) {
			(*test).I[i].ChangeSize(NcatCode[item]);
			(*test).I[i].a = 1.0;	// these lines starting values
			if (NcatCode[item] == 2) (*test).I[i].bj[0] = 0.0;
			else
				for (k = 0; k < (NcatCode[item] - 1); k++)
					(*test).I[i].bj[k] = -1.5 + 3.0*((double) k/(NcatCode[item] - 2));
			(*test).I[i].kind = 1;
			(*test).I[i].ncat = NcatCode[item];
 			for (int j=0; j<(*test).I[i].ncat; j++)
				(*test).I[i].T[j].resize(IRT10em::nqpt);
  			(*test).graded(i);
   			(*test).I[i].E.resize(IRT10em::nqpt);
			for (int q=0; q<IRT10em::nqpt; q++)
				(*test).I[i].E[q].resize((*test).I[i].ncat);
   		}
  	} // end of loop over items to set start values
  	x = new int[Items]; 
	likelihood.resize(IRT10em::nqpt);

// loop over cycles --- in irtlrdif this is for all-items-equal-parameters
	for (cycle = 0; cycle < 200; cycle++) {
		if (lots > 0) outfile1 << "cycle " << cycle << " ";
		cout << "cycle " << cycle << " "; 
		maxchange = 0;
// E-step
		loglikelihood = 0;
		for (i = 0; i < Items; i++) {
			for (int q=0; q<IRT10em::nqpt; q++)
				(*test).I[i].E[q]=0;
		}
// loop over persons
		Etime1 = clock();
		for (p = 0; p < nppl; p++) {
			for (i = 0; i < Items; i++)  
				x[i] = X[p][i]; 

			likelihood = IRT10em::popdist;
			for (i = 0; i < Items; i++) { // if in line below added for missing data
				if (x[i] != missing) likelihood = likelihood * 
							(*test).I[i].T[x[i]]; 
			} // end of loop over items to compute joint likelihoods
			loglikelihood += log(likelihood.sum());
			likelihood = likelihood/likelihood.sum(); // normalize to 1 obs
// add this person's posterior to row X(p,Permutation(ii+Offset(kk)))
// of each E table... loop over items' E tables
			for (i = 0; i < Items; i++) {
				if (x[i] != missing) {
					for (q = 0; q < IRT10em::nqpt; q++) 
						(*test).I[i].E[q][x[i]]  
							+= likelihood[q];
				}
			} // end of loop over items' E tables
		} // end of loop over people
		Etime2 = clock();
		Etime += ( (double) Etime2 - Etime1) / CLOCKS_PER_SEC;
		if (lots > 0) outfile1 << "loglikelihood: " << loglikelihood << " ";
		cout << "loglikelihood: " << loglikelihood << " " << endl;
// M-step
		Mtime1 = clock();
		for (i = 0; i < Items; i++) {
   			if (NcatCode[i] == 1) {
				M3PL_LL M3PL(&(*test).I[i], i); // loglikehood "object"
				MLE_D_FI mle_d_fi(M3PL,20,0.0001);    // mle "object" 
				Para.ReSize(3); 	// starting values			
				ParaOld.ReSize(3);
				Para << (*test).I[i].a 
					<< -1.7*(*test).I[i].a*(*test).I[i].b 
					<< log((*test).I[i].c/(1 - (*test).I[i].c));         
				ParaOld = Para;
				mle_d_fi.Fit(Para);                       // do the fit
				maxcheck = (Para - ParaOld).MaximumAbsoluteValue();
				if (maxcheck > maxchange) maxchange = maxcheck;
				(*test).I[i].a = Para(1);	
				(*test).I[i].b = -Para(2)/(1.7*Para(1));	
				(*test).I[i].c = 1.0/(1.0+exp(-Para(3)));	
   				(*test).threePL(i);
   			} // end of 3PL ml section
   			else {
				MGR_LL MGR(&(*test).I[i], i);  // loglikehood "object"
				MLE_D_FI mle_d_fi(MGR,20,0.0001);    // mle "object"
				ncats = (*test).I[i].ncat;
				Para.ReSize(ncats);
				ParaOld.ReSize(ncats);
				Para (1) = (*test).I[i].a;  	// starting values
				if (ncats == 2) Para(2) = -(*test).I[i].a * (*test).I[i].bj[0];
				else
					for (k = 0; k < (ncats - 1); k++)
						Para(k + 2) = -(*test).I[i].a * (*test).I[i].bj[k];
				ParaOld = Para;
				mle_d_fi.Fit(Para);                       // do the fit
				maxcheck = (Para - ParaOld).MaximumAbsoluteValue();
				if (maxcheck > maxchange) maxchange = maxcheck;
				(*test).I[i].a = Para(1);	
					for (k = 0; k < (ncats - 1); k++)
						(*test).I[i].bj[k] = -Para(k + 2)/Para(1);
   				(*test).graded(i);
   			} // end of graded ml section
   		} // end of M-step loop over items

		Mtime2 = clock();
		Mtime += ( (double) Mtime2 - Mtime1) / CLOCKS_PER_SEC;
// check convergence
		if (lots > 0) outfile1 << "maxchange: " << maxchange << endl;
		if (lots > 0) cout << "maxchange: " << maxchange << endl;
		if (maxchange < 0.001) { 
			if (lots > 0) {
				outfile1 << setprecision(2)
					<< setiosflags(ios::showpoint | ios::fixed);
				outfile1 << "E-step " << Etime << " seconds; M-step " 
					<< Mtime << " seconds " << endl;
				outfile1 << "Total " << Mtime + Etime << " seconds" << endl;
				outfile1 << resetiosflags(ios::showpoint | ios::fixed);
			}
			cycle = 201;
		}
	} // end of loop over EM cycles

	(*test).WriteIt ();
	
	delete[] x; 
} // end of EMfit



